function [ca,cc] = creationoperators(N)
%create creation and annihilation operators; N: number of majoranas
 g=gammamatrices(N);
 ca= createArrays(N/2,2^(N/2));
 cc= createArrays(N/2,2^(N/2));
 cnt=1;
for i = 1:2:N-1
   
      ca{cnt} = (g{i}+1i*g{i+1})/2;%  annihilation operator
      cc{cnt} = (g{i}-1i*g{i+1})/2;% creation operator
      cnt=cnt+1;
end

end

function result = createArrays(nArrays, arraySize)
    result = cell(1, nArrays);
    for i = 1 : nArrays
        result{i} = zeros(arraySize);
    end
end