N=10;
nt1=4;nt2=7;

[ca,cc] = creationoperators(2*N);
[hmut1,hmut2,hmunt,ht1,htnt,ht2,hd,hu]=kitaevchain_3segments_hamiltonian_7param(N,nt1,nt2,cc,ca);


g=gammamatrices(2*N);
g5 =(1i^N)*(eye(2^N)); %g5 operator for parity check
for i= 1:2*N
g5 = g5*g{i};
end

%Genetic Algorithm search
fitness=@(x)objective(g5,hmut1,hmut2,hmunt,ht1,htnt,ht2,hd,hu,x(1),x(2),x(3),x(4),x(5),x(6),x(7));
ConstraintFunction_ga_1=@(x)constraint(g5,hmut1,hmut2,hmunt,ht1,htnt,ht2,hd,hu,x(1),x(2),x(3),x(4),x(5),x(6),x(7));
nvar=7;
lb=[0.1 0.1 3 0.1 0.1 0.001 0.1];
ub=[1 1 10 1 1 1 1];


rng default;
hybridopts = optimoptions('fmincon','Display','iter','Algorithm','sqp');
options = optimoptions('ga','MutationFcn','mutationadaptfeasible',...
  'SelectionFcn',{'selectiontournament',2},'Display','final','UseParallel',true,'HybridFcn',{@fmincon,hybridopts}...
  ,'FunctionTolerance',1e-6,'MaxStallGenerations',100);
[x,fval,exitflag,output,population,scores] = ga(fitness,nvar,[],[],[],[],lb,ub,ConstraintFunction_ga_1,options);

disp("The SYK point is:");
disp(x);