function[hmut1,hmut2,hmunt,ht1,htnt,ht2,hd,hu]=kitaevchain_3segments_hamiltonian_7param(N,nt1,nt2,cc,ca)


hmut1 = zeros(2^N);
hmut2 = zeros(2^N);
hmunt = zeros(2^N);
htnt = zeros(2^N);
ht2 = zeros(2^N);
ht1 = zeros(2^N);
hd = zeros(2^N);


for i=1:nt1-1
hmut1=hmut1-((cc{i}*ca{i})-0.5*eye(2^N));
end

for i=nt1:nt2
hmunt=hmunt-((cc{i}*ca{i})-0.5*eye(2^N));
end

for i=nt2+1:N
hmut2=hmut2-((cc{i}*ca{i})-0.5*eye(2^N));
end

for i=1:nt1-1
ht1=ht1-(cc{i}*ca{i+1}+cc{i+1}*ca{i});
end

for i=nt1:nt2-1
htnt=htnt-(cc{i}*ca{i+1}+cc{i+1}*ca{i});
end

for i=nt2:N-1
ht2=ht2-(cc{i}*ca{i+1}+cc{i+1}*ca{i});
end

for i=1:N-1
hd=hd+(ca{i}*ca{i+1}+cc{i+1}*cc{i});
end

hu=nonlocalinteraction(N,ca,cc);

end

function[hu]=nonlocalinteraction(N,ca,cc)
hu = zeros(2^N);
nd=1:N;
ux=combnk(nd,2);
[m,~] =size(ux);
for i = 1 : m
    ind1=ux(i,1);
    ind2=ux(i,2);
    hu=hu+(cc{ind1}*ca{ind1}*cc{ind2}*ca{ind2});
end
end