N=10;
nt11=3; nt12=4;
nt21=7; nt22=8;

[ca,cc] = creationoperators(2*N);
[hmut1,hmut2,hmut3,hmunt1,hmunt2,ht,hd,hu]=kitaevchain_5segments_hamiltonian(N,nt11,nt12,nt21,nt22,cc,ca);

g=gammamatrices(2*N);
g5 =(1i^N)*(eye(2^N)); %gamma5 operator for parity check
for i= 1:2*N
g5 = g5*g{i};
end

%Genetic Algorithm search
fitness=@(x)objective(g5,hmut1,hmut2,hmut3,hmunt1,hmunt2,ht,hd,hu,x(1),x(2),x(3),x(4),x(5),x(6),x(7),x(8));
ConstraintFunction_ga_1=@(x)constraint(g5,hmut1,hmut2,hmut3,hmunt1,hmunt2,ht,hd,hu,x(1),x(2),x(3),x(4),x(5),x(6),x(7),x(8));
nvar=8;
lb=[0.1 0.1 0.1 3 3 0.1 0.1 0.01];
ub=[1 1 1 10 10 1 1 1];


rng default;
hybridopts = optimoptions('fmincon','Display','iter','Algorithm','sqp');
options = optimoptions('ga','MutationFcn','mutationadaptfeasible',...
  'SelectionFcn',{'selectiontournament',2},'Display','final','UseParallel',true,'HybridFcn',{@fmincon,hybridopts}...
  ,'FunctionTolerance',1e-6,'MaxStallGenerations',1000);
[x,fval,exitflag,output,population,scores] = ga(fitness,nvar,[],[],[],[],lb,ub,ConstraintFunction_ga_1,options); 

disp("The SYK point is:");
disp(x);

