
N=10;
nt1=4; nt2=7;
U=0;


[ca,cc] = creationoperators(2*N);
[hmut1,hmut2,hmunt,ht,hd,hu]=kitaevchain_3segments_hamiltonian(N,nt1,nt2,cc,ca);


%% search algorithms
rng default
ms = MultiStart('FunctionTolerance',1e-10,'UseParallel',true);
gs = GlobalSearch(ms);s
options = optimoptions(@fmincon,'Algorithm','interior-point','MaxIterations',3000);
 fun = @(x) egap(hmut1,hmut2,hmunt,ht,hd,hu,x(1),x(2),x(3),x(4),x(5),U);
problem = createOptimProblem('fmincon','x0',[0.1 0.1 3 0.1 0.1],...
    'objective',fun,'lb',[0.1 0.1 3 0.1 0.1],'ub',[1 1 10 1 1],'options',options);
[x,fval] = run(gs,problem);

disp("The optimal point is:");
disp(x);

%% E_|11>-E_|00> function
function[egap1]=egap(hmut1,hmut2,hmunt,ht,hd,hu,mut1,mut2,munt,t,del,U)
h=mut1*hmut1+mut2*hmut2+munt*hmunt+t*ht+del*hd+U*hu;
e=eig(h);
egap1=e(4)-e(1);
end

