function[hmut1,hmut2,hmunt,ht,hd,hu]=kitaevchain_3segments_hamiltonian(N,nt1,nt2,cc,ca)

%create hamitonian
hmut1 = zeros(2^(N));
hmut2 = zeros(2^(N));
hmunt = zeros(2^(N));
ht = zeros(2^(N));
hd = zeros(2^(N));

for i=1:nt1-1
hmut1=hmut1-((cc{i}*ca{i})-0.5*eye(2^N));
end

for i=nt1:nt2
hmunt=hmunt-((cc{i}*ca{i})-0.5*eye(2^N));
end

for i=nt2+1:N
hmut2=hmut2-((cc{i}*ca{i})-0.5*eye(2^N));
end

for i=1:N-1
ht=ht-(cc{i}*ca{i+1}+cc{i+1}*ca{i});
end

for i=1:N-1
hd=hd+(ca{i}*ca{i+1}+cc{i+1}*cc{i});
end

hu=nonlocalinteraction(N,ca,cc);
end



function[hu]=nonlocalinteraction(N,ca,cc)
hu = zeros(2^N);
nd=1:N;
ux=combnk(nd,2);
[m,~] =size(ux);
for i = 1 : m
    ind1=ux(i,1);
    ind2=ux(i,2);
    hu=hu+(cc{ind1}*ca{ind1}*cc{ind2}*ca{ind2});
end
end
